PrefabFiles = {
	"marisa",
	"wizard_cap",
	"broom",
	"magic_broom",
	"magic_potion",
	"magic_broom_light",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/marisa.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/marisa.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/marisa.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/marisa.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/marisa_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/marisa_silho.xml" ),

    Asset( "IMAGE", "bigportraits/marisa.tex" ),
    Asset( "ATLAS", "bigportraits/marisa.xml" ),
	
	Asset( "IMAGE", "images/map_icons/marisa.tex" ),
	Asset( "ATLAS", "images/map_icons/marisa.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_marisa.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_marisa.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_marisa.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_marisa.xml" ),

	Asset( "ATLAS", "images/hud/marisatab.xml" ),
	Asset( "IMAGE", "images/hud/marisatab.tex" ),
	
	Asset( "ATLAS", "images/inventoryimages/magic_potion.xml" ),
	Asset( "IMAGE", "images/inventoryimages/magic_potion.tex" ),
	
	Asset( "ATLAS", "images/inventoryimages/broom.xml" ),
	Asset( "IMAGE", "images/inventoryimages/broom.tex" ),
	
	Asset( "IMAGE", "images/avatars/self_inspect_marisa.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_marisa.xml" ),
}

local require = GLOBAL.require
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
local Recipe = GLOBAL.Recipe
local EventHandler = GLOBAL.EventHandler
local Action = GLOBAL.Action
local ACTIONS = GLOBAL.ACTIONS
local ActionHandler = GLOBAL.ActionHandler
local TUNING = GLOBAL.TUNING
local STRINGS = GLOBAL.STRINGS
local Lerp = GLOBAL.Lerp
local SpawnPrefab = GLOBAL.SpawnPrefab
local FindWalkableOffset = GLOBAL.FindWalkableOffset
local PI = GLOBAL.PI
local Vector3 = GLOBAL.Vector3
--local debug = GLOBAL.debug
local GetPlayer = GLOBAL.GetPlayer
local IsHUDPaused = GLOBAL.IsPaused
local TheInput = GLOBAL.TheInput
local TheFrontEnd = GLOBAL.TheFrontEnd
local TheSim = GLOBAL.TheSim

--modinfo
local IsServer = GLOBAL.TheNet:GetIsServer()
--local DifficultHealth = GetModConfigData("difficulthealth")

TUNING.LANG = GetModConfigData("lang")
TUNING.MARISA_BASE_HP = GetModConfigData("health")
TUNING.MARISA_BASE_SANITY = GetModConfigData("sanity")
TUNING.MARISA_BASE_HUNGER = GetModConfigData("hunger")
TUNING.MAGIC_BROOM_BASE_HUNGER = GetModConfigData("hunger_multi")
TUNING.MAGIC_BROOM_BASE_SPEED = GetModConfigData("speed_multi")
TUNING.NORMAL_BROOM_BASE_SPEED = GetModConfigData("speed_multi1")
TUNING.MAGIC_BROOM_DAMAGE = GetModConfigData("broom_damage")
TUNING.MAGIC_BROOM_DURABILITY = GetModConfigData("magic_broom_durability")
TUNING.NORMAL_BROOM_DURABILITY = GetModConfigData("normal_broom_durability")
TUNING.NORMAL_BROOM_DAMAGE = GetModConfigData("normal_broom_damage")

--Marisa Tab

local marisatab = AddRecipeTab( "Marisa's Tab", 514, "images/hud/marisatab.xml", "marisatab.tex", "marisa_builder")
--(name, ingredients, tab, level,     placer, min_spacing, nounlock, numtogive,                 builder_tag,          atlas, image)

--这？
local broom1 = GLOBAL.Ingredient( "broom", 1,"images/inventoryimages/broom.xml")
local magic_potion1 = GLOBAL.Ingredient( "magic_potion", 1,"images/inventoryimages/magic_potion.xml")

AddRecipe("broom", 
{GLOBAL.Ingredient("cutgrass", 6), GLOBAL.Ingredient("twigs", 3)}, 
marisatab, TECH.NONE, nil, nil, nil, nil, "marisa_builder", 
"images/inventoryimages/broom.xml", "broom.tex" )

AddRecipe("wizard_cap", 
{GLOBAL.Ingredient("silk", 6), magic_potion1,  GLOBAL.Ingredient("feather_crow", 1),}, 
marisatab, TECH.NONE, nil, nil, nil, nil,  "marisa_builder", 
"images/inventoryimages/wizard_cap.xml", "wizard_cap.tex" )

AddRecipe("magic_potion", 
{GLOBAL.Ingredient("red_cap", 1),  GLOBAL.Ingredient("blue_cap", 1),  GLOBAL.Ingredient("green_cap", 1),}, 
marisatab, TECH.SCIENCE_ONE, nil, nil, nil, nil,   "marisa_builder", 
"images/inventoryimages/magic_potion.xml", "magic_potion.tex" )

AddRecipe("magic_broom", 
{broom1, magic_potion1,GLOBAL.Ingredient("goldnugget", 2)},  
marisatab, TECH.SCIENCE_TWO,  nil, nil, nil, nil,   "marisa_builder", 
"images/inventoryimages/magic_broom.xml", "magic_broom.tex" )

--AddRecipe("krampus_sack", 
--{GLOBAL.Ingredient("silk", 20), GLOBAL.Ingredient("manrabbit_tail", 10), GLOBAL.Ingredient("cutreeds", 10)}, 
--marisatab, TECH.MAGIC_TWO, nil, nil, nil, nil, "marisa_builder", 
--nil, nil)

Recipe("krampus_sack", {Ingredient("silk", 20), Ingredient("manrabbit_tail", 10), Ingredient("cutreeds", 10)}, marisatab, TECH.MAGIC_TWO, nil, nil, nil, nil, "marisa_builder")

--STRINGS.NAMES.BROOM = "扫帚"
--STRINGS.NAMES.MAGIC_BROOM = "魔法扫帚"
--STRINGS.NAMES.MAGIC_POTION = "魔法药水"
--STRINGS.NAMES.WIZARD_CAP = "魔法帽"

--STRINGS.RECIPE_DESC.BROOM = "一把普通的扫帚\n拿着它身体仿佛会变轻。e" 
--STRINGS.RECIPE_DESC.MAGIC_BROOM = "魔理沙的魔法扫帚!!e" 
--STRINGS.RECIPE_DESC.MAGIC_POTION = "蘑菇？魔法！！e" 
--STRINGS.RECIPE_DESC.WIZARD_CAP = "魔法使专属的帽子e" 

--STRINGS.CHARACTERS.GENERIC.DESCRIBE.BROOM = "就算拿着它我也飞不起来" 
--STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGIC_BROOM = "我心爱的小扫帚，带我飞！" 
--STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGIC_POTION = "通过提取蘑菇的魔力制造而成" 
--STRINGS.CHARACTERS.GENERIC.DESCRIBE.WIZARD_CAP = "魔女和魔法使都喜欢戴的帽子" 
	
	
if TUNING.LANG == 1 then
	-- The character select screen lines
	STRINGS.CHARACTER_TITLES.marisa = "An ordinary human magician"
	STRINGS.CHARACTER_NAMES.marisa = "Marisa Kirisame"
	STRINGS.CHARACTER_DESCRIPTIONS.marisa = "*Black and white\n*Mushroom lover\n*An ordinary human magician"
	STRINGS.CHARACTER_QUOTES.marisa = "\"Danmaku's all about firepower.\""
else
	STRINGS.CHARACTER_TITLES.marisa = "普通的魔法使"
	STRINGS.CHARACTER_NAMES.marisa = "雾雨魔理沙"
	STRINGS.CHARACTER_DESCRIPTIONS.marisa = "*黑白\n*喜欢蘑菇\n*目前只是普通的人类魔法使 "
	STRINGS.CHARACTER_QUOTES.marisa = "\"不华丽就不是魔法了，弹幕最重要的是火力\""
end


if TUNING.LANG == 1 then
	-- Custom speech strings
	STRINGS.CHARACTERS.MARISA = require "speech_marisa_en"
else
	STRINGS.CHARACTERS.MARISA = require "speech_marisa_cn"
end

if TUNING.LANG == 1 then
	-- The character's name as appears in-game 
	STRINGS.NAMES.MARISA = "Marisa"
else
	STRINGS.NAMES.MARISA = "魔理沙"
end

if TUNING.LANG == 1 then
	-- The default responses of examining the character
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.MARISA =
	{
		GENERIC = "Hey！Marisa！",
		ATTACKER = "That Marisa looks shifty...",
		MURDERER = "Murderer!",
		REVIVER = "Marisa, friend of ghosts.",
		GHOST = "Marisa needs a 1up.",
	}
else

	STRINGS.CHARACTERS.GENERIC.DESCRIBE.MARISA =
	{
		GENERIC = "哦哦，是魔理沙",
		ATTACKER = "这魔理沙看起来狡猾狡猾的",
		MURDERER = "杀人凶手！",
		REVIVER = "魔理沙，我的救命恩人",
		GHOST = "魔理沙需要额外的残机",
	}
end

AddMinimapAtlas("images/map_icons/marisa.xml")

-- Add mod character to mod character list. Also specify a gender. Possible genders are MALE, FEMALE, ROBOT, NEUTRAL, and PLURAL.
AddModCharacter("marisa", "FEMALE")

